VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Viewport"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private hDC As Long, hOldPen As Long, hOldBM As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hDC As Long, ByVal nBkMode As Long) As Long
Public bmWidth As Long, bmHeight As Long
Public hBackDC As Long, xoff As Long, yoff As Long, XBmp As Long
Public Text As String, tyoff As Long

Public Sub render(ByVal pb As PictureBox)
    Dim rc As RECT
    
    BitBlt hDC, 0, 0, bmWidth, bmHeight, hBackDC, XBmp, yoff, vbSrcCopy

    rc.Top = 1
    rc.Right = tyoff
    rc.Bottom = bmHeight
    DrawText hDC, Text, -1, rc, 2 'DT_CENTER
    BitBlt pb.hDC, 0, 0, bmWidth, bmHeight, hDC, 0, 0, vbSrcCopy
End Sub

Public Sub CreateDC(ByVal pb As PictureBox)
    bmWidth = pb.ScaleWidth
    bmWidth = pb.Width / 15
    bmHeight = pb.ScaleHeight
    hDC = CreateCompatibleDC(0)
    hOldPen = SelectObject(hDC, CreatePen(0, pb.DrawWidth, pb.ForeColor))
    hOldBM = SelectObject(hDC, CreateCompatibleBitmap(pb.hDC, bmWidth, bmHeight))
    SetBkMode hDC, 1 'TRANSPARENT
End Sub

Private Sub Class_Terminate()
    DeleteObject SelectObject(hDC, hOldBM)
    DeleteObject SelectObject(hDC, hOldPen)
    DeleteDC hDC
End Sub

